import { type DRP, type ResolveConflictsType, SemanticsType, type Vertex } from "@sfroment/object";
export declare enum MapConflictResolution {
    SetWins = 0,
    DeleteWins = 1
}
export declare class MapDRP<K, V> implements DRP {
    semanticsType: SemanticsType;
    private _conflictResolution;
    private _map;
    constructor(conflictResolution?: MapConflictResolution);
    set(key: K, value: V): void;
    delete(key: K): void;
    query_has(key: K): boolean;
    query_get(key: K): V | undefined;
    query_entries(): [K, V][];
    query_keys(): K[];
    query_values(): V[];
    private _computeHash;
    resolveConflicts(vertices: Vertex[]): ResolveConflictsType;
}
//# sourceMappingURL=index.d.ts.map